import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Label;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JColorChooser;
import javax.swing.JComboBox;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

public class DDCtrlDrawPanel extends JPanel implements ActionListener {
	//
	DDControlDialog ctrl;
	//
	RectPanel rectPanelPen;
	JComboBox<Integer> comboSizePen=new JComboBox<Integer>(new Integer[]{1,2,3,4,5,6,7,8,9,10,11,12,13,14,15});
	//
	RectPanel rectPanelErs;
	JComboBox<Integer> comboSizeErs=new JComboBox<Integer>(new Integer[]{1,2,3,4,5,6,7,8,9,10,11,12,13,14,15});
	//
	JButton buttonColor=new JButton("I");
	JTextField fieldColor=new JTextField("",3);
	//******************************************************************************************************
	//
	//------------------------------------------------------------------------------------------------------
	public DDCtrlDrawPanel(DDControlDialog cD){
		//
		ctrl=cD;
		//
		fieldColor.setEditable(false);
		fieldColor.setBackground(Color.BLACK);
		ctrl.mDrawColor=Color.BLACK;
		//
		JPanel panelInfo=new JPanel();
		panelInfo.setLayout(new BorderLayout());
		panelInfo.add(new Label("`恄Fdrag"),BorderLayout.NORTH);
		panelInfo.add(new Label("FEdragA܂́Acontrol+drag"),BorderLayout.CENTER);
		//
		rectPanelPen=new RectPanel(ctrl,RectPanel.T_PEN);
		rectPanelPen.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLoweredBevelBorder()));
		rectPanelPen.setPreferredSize(new Dimension(50,50));
		//2-1
		JPanel panelPenColor=new JPanel();
		panelPenColor.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"`̐F"));	//g
		panelPenColor.add(buttonColor);
		panelPenColor.add(fieldColor);
		//2-2
		JPanel panelPenSize=new JPanel();
		panelPenSize.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"`̑"));	//g
		panelPenSize.add(comboSizePen);
		panelPenSize.add(rectPanelPen);
		//2
		JPanel panelPen=new JPanel();
		panelPen.setLayout(new BorderLayout());
		panelPen.add(panelPenColor, BorderLayout.NORTH);
		panelPen.add(panelPenSize, BorderLayout.CENTER);
		//
		rectPanelErs=new RectPanel(ctrl,RectPanel.T_ERASER);
		rectPanelErs.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLoweredBevelBorder()));
		rectPanelErs.setPreferredSize(new Dimension(50,50));
		//3
		JPanel panelErsSize=new JPanel();
		panelErsSize.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"̑"));	//g
		panelErsSize.add(comboSizeErs);
		panelErsSize.add(rectPanelErs);
		//
		setLayout(new BorderLayout());
		add(panelInfo,BorderLayout.NORTH);
		add(panelPen,BorderLayout.CENTER);
		add(panelErsSize,BorderLayout.SOUTH);
		//
		//
		comboSizePen.setSelectedItem(3);
		ctrl.mDrawSizePen=3;
		//
		comboSizeErs.setSelectedItem(10);
		ctrl.mDrawSizeErs=10;
		//
		comboSizePen.addActionListener(this);
		comboSizeErs.addActionListener(this);
		buttonColor.addActionListener(this);
	}
	//******************************************************************************************************
	//{^Cxg
	//------------------------------------------------------------------------------------------------------
	public void actionPerformed(ActionEvent e) {
		Object object=e.getSource();
		if(object==comboSizePen){
			//
			ctrl.mDrawSizePen=(Integer)(comboSizePen.getSelectedItem());
			//
			rectPanelPen.repaint();
		}else if(object==comboSizeErs){
			//
			ctrl.mDrawSizeErs=(Integer)(comboSizeErs.getSelectedItem());
			//
			rectPanelErs.repaint();
		}else if(object==buttonColor){
			Color tmpColor=JColorChooser.showDialog(this,"`FI",fieldColor.getBackground());
			if(tmpColor!=null){
				//
				if(tmpColor.equals(Color.WHITE)){
					JOptionPane.showMessageDialog(this,	"F͎wł܂","G[",JOptionPane.ERROR_MESSAGE);
					return;
				}
				//
				ctrl.mDrawColor=tmpColor;
				fieldColor.setBackground(tmpColor);
				//
				rectPanelPen.repaint();
			}
		}
		//
		ctrl.fieldRequestFocus();
	}
	//******************************************************************************************************
	//Ci[NX
	//------------------------------------------------------------------------------------------------------
	//
	class RectPanel extends JPanel{
		//
		static final int T_PEN=0;
		static final int T_ERASER=1;
		//
		DDControlDialog ctrl;
		int type;
		//
		public RectPanel(DDControlDialog cD,int t){
			ctrl=cD;
			type=t;
		}
		//
		public void paintComponent(Graphics g){
			super.paintComponent(g);	//KviꂪȂƔwiFœhԂȂj
			//
			if(type==T_PEN){
				int x=(getSize().width-ctrl.mDrawSizePen)>>1;
				int y=(getSize().height-ctrl.mDrawSizePen)>>1;
				//
				g.setColor(ctrl.mDrawColor);
				g.fillRect(x,y,ctrl.mDrawSizePen,ctrl.mDrawSizePen);
			}else if(type==T_ERASER){
				int x=(getSize().width-ctrl.mDrawSizeErs)>>1;
				int y=(getSize().height-ctrl.mDrawSizeErs)>>1;
				//
				g.setColor(Color.BLACK);
				g.drawRect(x,y,ctrl.mDrawSizeErs,ctrl.mDrawSizeErs);
			}
		}
	}
}
