import java.awt.Component;
import java.awt.Dimension;
import java.awt.Image;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.image.MemoryImageSource;
import java.awt.image.PixelGrabber;
import java.util.ArrayList;

public class DDData extends Component {
	//----------萔------------
	//
	static final int PIX_ZERO=0x00<<24 | 0xff<<16 | 0xff<<8 | 0xff;
	//
	static final int DEF_WIDTH=600;
	static final int DEF_HEIGHT=800;
	//
	static final int R_GRIP=3;
	//
	static final int S_GROUP=0;
	static final int S_NUMBER=1;
	static final int S_TYPE=2;
	static final int S_ALL_NUM=2;
	static final int S_ALL_DOT=3;
	//
	static final int ST_NULL=-1;
	static final int ST_FREE=0;
	static final int ST_NUM=1;
	//
	static final int NO_DATA=-1;
	//----------ϐ------------
	int width,height;
	//
	Image backImage=null;
	Image drawImage=null;
	//
	DDGroup[] groups;
	//
	ArrayList<int[]> dotsSelected;
	int[] dotGriped;
	int[] numGriped;
	//
	int[] dotOvered;
	int[] numOvered;
	//******************************************************************************************************
	//
	//------------------------------------------------------------------------------------------------------
	public DDData(){
		formatPuzzle(DEF_WIDTH,DEF_HEIGHT,DDGroup.DEF_DOT_MAX);
	}
	//******************************************************************************************************
	// VKEύX
	//------------------------------------------------------------------------------------------------------
	//wTCYŐVpY쐬
	public void formatPuzzle(int wd,int ht,int dMx){
		width=wd;
		height=ht;
		//
		formatDrawImage();
		setBackImage(null);
		//
		groups=new DDGroup[1];
		groups[0]=new DDGroup(dMx,this);
		//
		dotsSelected=new ArrayList<int[]>();
		dotGriped=null;
		numGriped=null;
		//
		dotOvered=null;
		numOvered=null;
	}
	//݂̃f[^̂܂܎cāAwTCYɕύX
	public String changePuzzle(int wd,int ht,int dMx){
		//===`FbN===
		if(wd<width || ht<height){	//TCYk
			for(int g=0;g<groups.length;g++){
				if( !groups[g].checkDotPos(wd,ht) ){
					return "͈͊Oɓ_܂B";
				}
			}
		}
		if(dMx<getNumberMax()){		//
			for(int g=0;g<groups.length;g++){
				if( !groups[g].checkDotIndex(dMx) ){
					return "wԍ𒴂_܂B";
				}
			}
		}
		//===Ă͂===
		if(width!=wd || height!=ht){
			//ɐiV[gj쐬
			String ret=changeDrawImage(wd,ht);
			if(ret!=null){
				return ret;
			}
			//G[Ȃ̂mF
			width=wd;
			height=ht;
		}
		for(int g=0;g<groups.length;g++){
			groups[g].adaptDotSize(dMx);
		}
		//wi
		//
		return null;
	}
	//******************************************************************************************************
	//
	//------------------------------------------------------------------------------------------------------
	//
	public void clearAllDot(){
		for(int g=0;g<groups.length;g++){
			groups[g].clearAllDot();
		}
		//
		dotsSelected.clear();
	}
	public String checkQuestion(){
		final String BR=System.getProperty("line.separator");
		//
		StringBuilder sb=new StringBuilder();
		//
		for(int g=0;g<groups.length;g++){
			sb.append("O[v "+(g+1)+" ").append(BR);
			sb.append(groups[g].checkQuestion()).append(BR);
		}
		//
		return sb.toString();
	}
	//
	public int getNumberMax(){
		return groups[0].dotNumber.length;
	}
	//******************************************************************************************************
	//backImage ́Eo
	//------------------------------------------------------------------------------------------------------
	public Image getBackImage(){
		return backImage;
	}
	public void setBackImage(Image img) {	//imgnull̂Ƃ
		backImage=img;
	}
	//******************************************************************************************************
	//drawImage VKEύX
	//------------------------------------------------------------------------------------------------------
	public void formatDrawImage(){
		//VK̃sNZ
		int[] pix=new int[width*height];
		for(int p=0;p<width*height;p++){
			pix[p]=PIX_ZERO;
		}
		//쐬
		MemoryImageSource mimg=new MemoryImageSource(width,height,pix,0,width);
		drawImage=createImage(mimg);
	}
	private String changeDrawImage(int newWd,int newHt){
		//ύXÕsNZo
		int[] oldPix=new int[width*height];
		try{
			//
			PixelGrabber pg=new PixelGrabber(drawImage,0,0,width,height,oldPix,0,width);
			pg.grabPixels();
		}catch(InterruptedException ie){
			return "̏ɃG[܂B"+System.getProperty("line.separator")+ie.getMessage();
		}
		//ύX̃sNZ
		int[] newPix=new int[newWd*newHt];
		for(int p=0;p<newWd*newHt;p++){
			newPix[p]=PIX_ZERO;
		}
		//sNZڂ
		int sWd=(width<newWd)?width:newWd;
		int sHt=(height<newHt)?height:newHt;
		for(int h=0;h<sHt;h++){
			for(int w=0;w<sWd;w++){
				newPix[newWd*h+w]=oldPix[width*h+w];
			}
		}
		//VTCYō쐬
		MemoryImageSource mimg=new MemoryImageSource(newWd,newHt,newPix,0,newWd);
		drawImage=createImage(mimg);
		//
		return null;
	}
	//******************************************************************************************************
	//drawImage ́Eo
	//------------------------------------------------------------------------------------------------------
	public Image getDrawImage(){
		if(drawImage==null){
			formatDrawImage();
		}
		//
		return drawImage;
	}
	public String setDrawImage(Image img){
		//===`FbN===
		if(img.getWidth(this)!=width || img.getHeight(this)!=height){
			return "̃TCYv܂B";
		}
		//===iV[gj̍쐬===
		//摜̐Fo
		int[] pix=new int[width*height];
		try{
			//
			PixelGrabber pg=new PixelGrabber(img,0,0,width,height,pix,0,width);
			pg.grabPixels();
		}catch(InterruptedException ie){
			return "̏ɃG[܂B"+System.getProperty("line.separator")+ie.getMessage();
		}
		//ߐFij̃sNZ𓧖ɂ
		for(int h=0;h<height;h++){
			for(int w=0;w<width;w++){
				//At@[lāARGB̕łȂ
				if( (pix[width*h+w] & 0x00ffffff)==0xffffff ){
					pix[width*h+w]=PIX_ZERO;
				}
			}
		}
		//zu摜쐬
		MemoryImageSource mimg=new MemoryImageSource(width,height,pix,0,width);
		drawImage=createImage(mimg);
		//
		return null;
	}
	//******************************************************************************************************
	//drawImage `
	//------------------------------------------------------------------------------------------------------
	public void drawDrawImage(int oldX,int oldY,int nowX,int nowY,boolean rightF,DDControlDialog ctrl) {
		//***sNZ̐Fo
		int[] pix=new int[width*height];
		try{
			//
			PixelGrabber pg=new PixelGrabber(drawImage,0,0,width,height,pix,0,width);
			pg.grabPixels();
		}catch(InterruptedException e){
			//
		}
		//***`isNZ𒼐ڕύXj
		int dx=nowX-oldX;
		int dy=nowY-oldY;
		if(Math.abs(dx) < Math.abs(dy)){	//
			if(dy>0){									//down
				for(int y=oldY;y<=nowY;y++){
					int x=Math.round(oldX+dx*(y-oldY)/dy);
					dotDrawImage(pix,x,y,rightF,ctrl);
				}
			}else if(dy<0){										//up
				for(int y=oldY;y>=nowY;y--){
					int x=Math.round(oldX+dx*(y-oldY)/dy);
					dotDrawImage(pix,x,y,rightF,ctrl);
				}
			}else{								//
				dotDrawImage(pix,nowX,nowY,rightF,ctrl);
			}
		}else{
			if(dx>0){									//right
				for(int x=oldX;x<=nowX;x++){
					int y=Math.round(oldY+dy*(x-oldX)/dx);
					dotDrawImage(pix,x,y,rightF,ctrl);
				}
			}else if(dx<0){										//left
				for(int x=oldX;x>=nowX;x--){
					int y=Math.round(oldY+dy*(x-oldX)/dx);
					dotDrawImage(pix,x,y,rightF,ctrl);
				}
			}else{								//
				dotDrawImage(pix,nowX,nowY,rightF,ctrl);
			}
		}
		//***摜쐬
		MemoryImageSource mimg=new MemoryImageSource(width,height,pix,0,width);
		drawImage=createImage(mimg);
	}
	private void dotDrawImage(int[] pix,int x,int py,boolean rightF,DDControlDialog ctrl){
		int r=ctrl.getDrawRadius(rightF);
		if( !rightF ){	//}EX{^i`j
			for(int h=py-r;h<py-r+ctrl.mDrawSizePen;h++){
				for(int w=x-r;w<x-r+ctrl.mDrawSizePen;w++){
					pix[width*h+w]=ctrl.mDrawColor.getRGB();
				}
			}
		}else{			//}EXE{^ij
			for(int h=py-r;h<py-r+ctrl.mDrawSizeErs;h++){
				for(int w=x-r;w<x-r+ctrl.mDrawSizeErs;w++){
					pix[width*h+w]=PIX_ZERO;
				}
			}
		}
	}
	//******************************************************************************************************
	// }EX NbNij
	//------------------------------------------------------------------------------------------------------
	public boolean addPoint(DDControlDialog ctrl,int px,int py){	//ύXtrueԂ
		//
		int[] dot=getDotFromPos(px,py);
		if( !checkDot(dot,ctrl) ){	//iŕʃO[v`FbNj
			return false;
		}
		//
		switch(ctrl.mPointAddOpt01){
		case DDControlDialog.MPO1_FREE:			//freeɂ
			switch(dot[S_TYPE]){
			case ST_NULL:		//VK
				groups[ctrl.mGroupSelected].addPointFree(px, py);
				break;
			case ST_FREE:		//free
				return false;
			case ST_NUM:		//number
				groups[ctrl.mGroupSelected].changePointFree(dot[S_NUMBER],ctrl);
				//
				ctrl.updateNumberList();	//***ԍXgXV***
				//
				break;
			}
			//
			break;
		case DDControlDialog.MPO1_NUM_EMPTY:	//numberɂ
		case DDControlDialog.MPO1_NUM_ALL:		//iEMPTYALL͒ŕʂ̂ŁAł͂Ȃj
			//Iigpԍ̂ݕ\ŃXgɂȂĂjȂ
			if(ctrl.mPointAddTargetIdx==DDControlDialog.NO_INDEX) {
				ctrl.frame.showErrorMessage("gԍcĂ܂B");
				return false;
			}
			//
			int targetNI=ctrl.mPointAddTargetIdx;
			switch(dot[S_TYPE]){
			case ST_NULL:		//VK
				if( !groups[ctrl.mGroupSelected].addPointNumber(px, py, targetNI, ctrl) ){
					return false;
				}
				break;
			case ST_FREE:		//free
				if( !groups[ctrl.mGroupSelected].changePointNumberFromFree(dot[S_NUMBER], targetNI, ctrl) ){
					return false;
				}
				break;
			case ST_NUM:		//number
				if( !groups[ctrl.mGroupSelected].changePointNumberFromNum(dot[S_NUMBER], targetNI, ctrl)){
					return false;
				}
				//
				break;
			}
			//
			ctrl.updateNumberList();	//***ԍXgXV***
			//
			break;
		}
		//
		return true;
	}
	public boolean deletePoint(DDControlDialog ctrl,int px,int py){		//ύXtrueԂ
		//
		int[] dot=getDotFromPos(px,py);
		if( !checkDot(dot,ctrl) ){	//iŕʃO[v`FbNj
			return false;
		}
		//
		switch(dot[S_TYPE]){
		case ST_NULL:		//IȂ
			return false;
		case ST_FREE:		//freeI
			groups[dot[S_GROUP]].deletePoint(dot[S_TYPE],dot[S_NUMBER],ctrl);
			break;
		case ST_NUM:		//numberI
			if(ctrl.mPointAddOpt02==DDControlDialog.MPO2_SLIDE){
				groups[dot[S_GROUP]].deletePointSlide(dot[S_NUMBER],ctrl);
			}else{
				groups[dot[S_GROUP]].deletePoint(dot[S_TYPE],dot[S_NUMBER],ctrl);
			}
			//
			ctrl.updateNumberList();	//***ԍXgXV***
			//
			break;
		}
		//
		return true;
	}
	public boolean selectPoint(DDControlDialog ctrl,int px,int py,boolean rightF){
		//
		int[] dot=getDotFromPos(px,py);
		if( !checkDot(dot,ctrl) ){	//iŕʃO[v`FbNj
			return false;
		}
		//
		switch(dot[S_TYPE]){
		case ST_NULL:		//
			return false;
		case ST_FREE:		//
		case ST_NUM:		//
			//
			switch(ctrl.mPointSelectOpt03){
			case DDControlDialog.MPO3_SINGLE:
				if( !rightF ){
					return selectDot(dot);
				}else{
					return disselectDot(dot);
				}
				//break;
			case DDControlDialog.MPO3_CONTINUE:
				//
				Point contA;
				if(dot[S_TYPE]==ST_FREE) {
					contA=new Point(dot[S_NUMBER],dot[S_NUMBER]);
				}else {
					contA=groups[dot[S_GROUP]].getContinueArea(dot[S_NUMBER]);
				}
				//
				boolean cF=false;
				for(int c=contA.x;c<=contA.y;c++) {
					if( !rightF ){
						if( selectDot(new int[] {dot[S_GROUP],c,dot[S_TYPE]}) ){
							cF=true;//
						}
					}else{
						if( disselectDot(new int[] {dot[S_GROUP],c,dot[S_TYPE]}) ){
							cF=true;//
						}
					}
				}
				//
				return cF;
				//break;
			case DDControlDialog.MPO3_GROUP:
				if( !rightF ){
					//
					ArrayList<int[]> tmpDS=groups[ctrl.mGroupSelected].selectAllDots(ctrl.mGroupSelected);
					if( dotsSelected.size()>=tmpDS.size() ) {
						return false;	//ɑSIĂ
					}else {
						dotsSelected=tmpDS;
						return true;
					}

					//return groups[ctrl.mGroupSelected].selectAllDots(dotsSelected, ctrl.mGroupSelected);
				}else{
					if(dotsSelected.size()>0){
						dotsSelected.clear();//
						return true;
					}else{
						return false;
					}
				}
				//break;
			default:	//dummy
				return false;
			}
			//
			//break;
		default:	//dummy
			return false;
		}
		//
		//return true;
	}
	//******************************************************************************************************
	// ij
	//------------------------------------------------------------------------------------------------------
	public boolean deleteSelectedDots(DDControlDialog ctrl){
		if(dotsSelected.size()<=0){
			return false;
		}else{
			int[] dot;
			for(int s=dotsSelected.size()-1;s>=0;s--){	//iォ珇ԂɁAI炵Ăj
				dot=dotsSelected.get(s);
				if(ctrl.mPointAddOpt02==DDControlDialog.MPO2_SLIDE){
					groups[dot[S_GROUP]].deletePointSlide(dot[S_NUMBER],ctrl);
				}else{
					groups[dot[S_GROUP]].deletePoint(dot[S_TYPE],dot[S_NUMBER],ctrl);
				}
			}
			//ł͕sv
			//dotsSelected.clear();
			//
			ctrl.updateNumberList();	//***ԍXgXV***
			//
			return true;
		}
	}
	public boolean isSelectedFromPos(DDControlDialog ctrl,int px,int py){
		//ԍƂ炦ĂȂ
		int[] dot=getDotFromPos(px,py);
		if(isDot(dot)){
			//_Ƃ炦ĂāA͓O[v
			if( dot[S_GROUP]==ctrl.mGroupSelected ){
				//̓_͑IĂ邩
				if(checkSelected(dot)!=NO_DATA){
					return true;
				}
			}
		}
		//
		return false;
	}
	//******************************************************************************************************
	//@ԍ̓K؂Ȉʒuij
	//------------------------------------------------------------------------------------------------------
	public void adjustNumberPos(int gNI){
		//
		for(int g=0;g<groups.length;g++){
			Point[] dotN=groups[g].dotNumber;
			//
			for(int d=0;d<dotN.length;d++){
				if(dotN[d]!=null){
					groups[g].setNumPos(d, getFitPos(dotN[d],gNI,d));
				}
			}
		}
	}
	public Point getFitPos(Point ptD,int gNI,int tNI){
		return getFitPos(ptD.x,ptD.y,gNI,tNI);
	}
	public Point getFitPos(int px,int py,int gNI,int tNI){
		//ׂӂ͈̔
		int radius=groups[gNI].markSize*5;
		//͈͓̓_
		ArrayList<Point> dList=new ArrayList<Point>();
		for(int g=0;g<groups.length;g++){
			dList=groups[g].getAroundDot(px, py, radius, dList);
		}
		//
		double vx=0;
		double vy=0;
		//
		final double L=radius*Math.cbrt(2);
		Point dPt;
		double len;
		double rad;
		//͈͓̓_
		for(int d=0;d<dList.size();d++){
			dPt=dList.get(d);
			len=L-Math.hypot(dPt.x-px, dPt.y-py);
			if(len==L){
				continue;
			}
			rad=Math.atan2( -(dPt.y-py),-(dPt.x-px) );	//_Ώ̂̈ʒuł̊px
			//
			vx+=len*Math.cos(rad);
			vy+=len*Math.sin(rad);
		}
		//
		//O̓_iW߂ƓdɎZĂ܂j
		if(tNI>0 && groups[gNI].dotNumber[tNI-1]!=null){
			dPt=groups[gNI].dotNumber[tNI-1];
			rad=Math.atan2( -(dPt.y-py),-(dPt.x-px) );	//_Ώ̂̈ʒuł̊px
			//
			vx+=L*Math.cos(rad);
			vy+=L*Math.sin(rad);
		}
		if(tNI<getNumberMax()-1 && groups[gNI].dotNumber[tNI+1]!=null){
			dPt=groups[gNI].dotNumber[tNI+1];
			rad=Math.atan2( -(dPt.y-py),-(dPt.x-px) );	//_Ώ̂̈ʒuł̊px
			//
			vx+=L*Math.cos(rad);
			vy+=L*Math.sin(rad);
		}
		//
		if(vx==0 && vy==0){
			rad=-Math.PI/2;				//defaultł͏
		}else{
			rad=Math.atan2( vy,vx );
		}
		//
		if(rad>Math.PI/2){			//
			return new Point( (int)(groups[gNI].markSize*Math.cos(rad)/2)-groups[gNI].markSize ,	 (int)(groups[gNI].markSize*Math.sin(rad)/2)+groups[gNI].markSize );
		}else if(rad>0){			//E
			return new Point( (int)(groups[gNI].markSize*Math.cos(rad)/2) ,							 (int)(groups[gNI].markSize*Math.sin(rad)/2)+groups[gNI].markSize );
		}else if(rad>-Math.PI/2){	//E
			return new Point( (int)(groups[gNI].markSize*Math.cos(rad)/2) ,							 (int)(groups[gNI].markSize*Math.sin(rad)/2) );
		}else{						//
			return new Point( (int)(groups[gNI].markSize*Math.cos(rad)/2)-groups[gNI].markSize ,	 (int)(groups[gNI].markSize*Math.sin(rad)/2) );
		}
	}
	//******************************************************************************************************
	// ij
	//------------------------------------------------------------------------------------------------------
	private int[] getDotFromPos(int px,int py){
		//
		for(int g=0;g<groups.length;g++){
			int[] dot=groups[g].getDotFromPos(px, py, g);
			if(dot!=null){
				return dot;
			}
		}
		//
		return new int[]{ST_NULL,ST_NULL,ST_NULL};
	}
	private static boolean checkDot(int[] dot,DDControlDialog ctrl){
		if( dot[S_GROUP]!= ST_NULL ){
			//
			if( !isDot(dot) ){
				return false;
			}
			//
			if(dot[S_GROUP]!=ctrl.mGroupSelected){
				ctrl.frame.showErrorMessage("ʃO[v̓_͑ł܂B");
				return false;
			}
		}
		//
		return true;
	}
	public static boolean isDot(int[] dot){
		if(dot.length>=S_ALL_DOT){
			return true;
		}else{
			return false;
		}
	}
	//******************************************************************************************************
	// groupij
	//------------------------------------------------------------------------------------------------------
	public boolean plusGroup(DDControlDialog ctrl){	//L[{[h
		if(groups.length<=1){
			return false;
		}else{
			if(ctrl.mGroupSelected>=groups.length-1){
				ctrl.setGroupData(0);
			}else{
				ctrl.setGroupData(ctrl.mGroupSelected+1);
			}
			//controlDialog.setGroupDatał܂Ƃ߂čs
			//dotsSelected.clear();
			return true;
		}
	}
	public boolean minusGroup(DDControlDialog ctrl){	//L[{[h
		if(groups.length<=1){
			return false;
		}else{
			if(ctrl.mGroupSelected<=0){
				ctrl.setGroupData(groups.length-1);
			}else{
				ctrl.setGroupData(ctrl.mGroupSelected-1);
			}
			//controlDialog.setGroupDatał܂Ƃ߂čs
			//dotsSelected.clear();
			return true;
		}
	}
	public boolean changeGroup(int gNI,DDControlDialog ctrl){	//L[{[h
		if(gNI<groups.length){
			if(gNI==ctrl.mGroupSelected){
				return false;
			}else{
				ctrl.setGroupData(gNI);
				//controlDialog.setGroupDatał܂Ƃ߂čs
				//dotsSelected.clear();
				return true;
			}
		}else{
			return false;
		}
	}
	public boolean changeGroup(int px,int py,DDControlDialog ctrl){	//}EXNbN
		//
		int[] dot=getDotFromPos(px,py);
		/*	_炾łȂAԍłO[vύXł悤ɂiS_TYPE͎QƂȂ̂OKj
		if( !isDot(dot) ){
			return false;
		}
		*/
		//
		if( dot[S_GROUP]== ST_NULL ){
			return false;
		}else{
			if(dot[S_GROUP]==ctrl.mGroupSelected){
				return false;
			}else{
				//
				ctrl.setGroupData(dot[S_GROUP]);
				//controlDialog.setGroupDatał܂Ƃ߂čs
				//dotsSelected.clear();
				return true;
			}
		}
	}
	//
	public int addGroup(){				//ControlPanel
		DDGroup[] tmpGroups=new DDGroup[groups.length+1];
		//
		for(int g=0;g<groups.length;g++){
			tmpGroups[g]=groups[g];
		}
		tmpGroups[groups.length]=new DDGroup(getNumberMax(),this);	//
		//
		groups=tmpGroups;
		//controlDialog.setGroupDatał܂Ƃ߂čs
		//dotsSelected.clear();
		//
		return groups.length-1;
	}
	public int deleteGroup(int gNI){	//ControlPanel
		DDGroup[] tmpGroups=new DDGroup[groups.length-1];
		//
		for(int g=0;g<gNI;g++){					//<gNI
			tmpGroups[g]=groups[g];
		}
		//
		for(int g=gNI+1;g<groups.length;g++){	//gNI<
			tmpGroups[g-1]=groups[g];	//-1
		}
		//
		groups=tmpGroups;
		//controlDialog.setGroupDatał܂Ƃ߂čs
		//dotsSelected.clear();
		//
		if(gNI==0){
			return gNI;
		}else{
			return gNI-1;
		}
	}
	//******************************************************************************************************
	// over ij
	//------------------------------------------------------------------------------------------------------
	public boolean overDot(int px,int py,DDControlDialog ctrl){
		//
		int[] dot=getDotFromPos(px,py);
		if( isDot(dot) ){	//(̏ꍇɗ)
			if( dot[S_GROUP]!= ST_NULL ){	//_
				if( dot[S_GROUP]==ctrl.mGroupSelected ){
					if(!dot.equals(dotOvered)){	//ύXL
						dotOvered=dot;
						numOvered=null;
						return true;
					}
				//}else{
					//ctrl.frame.showErrorMessage("ʃO[v̓_͑ł܂B");
				}
			}else{							//
				return disoverDot();
			}
		}else{								//ԍ
			if( dot[S_GROUP]==ctrl.mGroupSelected ){
				if(!dot.equals(numOvered)){		//ύXL
					dotOvered=null;
					numOvered=dot;
					return true;
				}
			}
		}
		//ύXȂÁA
		return false;
	}
	public boolean disoverDot(){
		if(dotOvered!=null || numOvered!=null){
			dotOvered=null;
			numOvered=null;
			return true;
		}else{
			return false;
		}
	}
	//******************************************************************************************************
	// grip ij
	//------------------------------------------------------------------------------------------------------
	public boolean gripDot(int px,int py,DDControlDialog ctrl){
		//
		int[] dot=getDotFromPos(px,py);
		if( isDot(dot) ){	//
			if( dot[S_GROUP]!= ST_NULL ){
				if( dot[S_GROUP]==ctrl.mGroupSelected ){
					dotGriped=dot;
					return true;
				//}else{
					//ctrl.frame.showErrorMessage("ʃO[v̓_͑ł܂B");
				}
			}
		}else{				//
			if( dot[S_GROUP]==ctrl.mGroupSelected ){
				numGriped=dot;
				return true;
			}
		}
		//
		return false;
	}
	public boolean disgripDot(){
		if(dotGriped!=null || numGriped!=null){
			dotGriped=null;
			numGriped=null;
			return true;
		}else{
			return false;
		}
	}
	//******************************************************************************************************
	// move ij
	//------------------------------------------------------------------------------------------------------
	public boolean moveGripedDot(int dx,int dy){
		if(numGriped!=null){
			//
			Dimension dimN=getMovableDistance(dx,dy,groups[numGriped[S_GROUP]].getNumArea(numGriped[S_NUMBER]));
			if(dimN.width==0 && dimN.height==0){
				return false;
			}
			//
			moveNum(dimN,numGriped);
			return true;
		}else if(dotGriped!=null){
			//
			if(checkSelected(dotGriped)!=NO_DATA){		//gripselectedɊ܂܂Ă΁AselectedSĂ𓮂
				//
				return moveSelectedDots(dx,dy);
			}else{										//܂܂ĂȂ΁Agrip݂̂𓮂
				//
				Dimension dimD=getMovableDistance(dx,dy,groups[dotGriped[S_GROUP]].getDotArea(dotGriped[S_TYPE], dotGriped[S_NUMBER]));
				if(dimD.width==0 && dimD.height==0){
					return false;
				}
				//
				moveDot(dimD,dotGriped);
				return true;
			}
		}else{
			return false;
		}
	}
	//num
	private void moveNum(Dimension dimN,int[] num){
		groups[num[S_GROUP]].numberPos[num[S_NUMBER]].x+=dimN.width;
		groups[num[S_GROUP]].numberPos[num[S_NUMBER]].y+=dimN.height;
	}
	//dot
	private void moveDot(Dimension dimD,int[] dot){
		switch(dot[S_TYPE]){
		case ST_NUM:
			groups[dot[S_GROUP]].dotNumber[dot[S_NUMBER]].x+=dimD.width;
			groups[dot[S_GROUP]].dotNumber[dot[S_NUMBER]].y+=dimD.height;
			break;
		case ST_FREE:
			groups[dot[S_GROUP]].dotFree.get(dot[S_NUMBER]).x+=dimD.width;
			groups[dot[S_GROUP]].dotFree.get(dot[S_NUMBER]).y+=dimD.height;
			break;
		}
	}
	//
	public boolean moveSelectedDots(int dx,int dy){
		//
		if( dotsSelected.size()<=0 ){
			return false;
		}
		//
		Dimension dimD=getMovableDistance(dx,dy,getSelectedDotsArea());
		if(dimD.width==0 && dimD.height==0){
			return false;
		}
		//
		for(int s=0;s<dotsSelected.size();s++){
			moveDot(dimD,dotsSelected.get(s));
		}
		//
		return true;
	}
	private Rectangle getSelectedDotsArea(){
		int up=height;
		int down=0;
		int right=0;
		int left=width;
		//
		for(int s=0;s<dotsSelected.size();s++){
			int[] dot=dotsSelected.get(s);
			Rectangle rectD=groups[dot[S_GROUP]].getDotArea(dot[S_TYPE], dot[S_NUMBER]);
			if(up>rectD.y){	up=rectD.y;	}
			if(down<rectD.height){	down=rectD.height;	}
			if(right<rectD.width){	right=rectD.width;	}
			if(left>rectD.x){	left=rectD.x;	}
		}
		//
		return new Rectangle(left,up,right,down);
	}
	private Dimension getMovableDistance(int dx,int dy,Rectangle rectD){
		Dimension dimD=new Dimension();
		if(dx>0){
			if(rectD.width+dx>=width){
				dimD.width=width-rectD.width;
			}else{
				dimD.width=dx;
			}
		}else{
			if(rectD.x+dx<=0){
				dimD.width=0-rectD.x;
			}else{
				dimD.width=dx;
			}
		}
		if(dy>0){
			if(rectD.height+dy>=height){
				dimD.height=height-rectD.height;
			}else{
				dimD.height=dy;
			}
		}else{
			if(rectD.y+dy<=0){
				dimD.height=0-rectD.y;
			}else{
				dimD.height=dy;
			}
		}
		//
		return dimD;
	}
	//******************************************************************************************************
	// selectij
	//------------------------------------------------------------------------------------------------------
	private boolean selectDot(int[] dot){
		int sIdx=checkSelected(dot);
		if(sIdx==NO_DATA){
			dotsSelected.add(dot);
			return true;
		}else{
			return false;
		}
	}
	private boolean disselectDot(int[] dot){
		int sIdx=checkSelected(dot);
		if(sIdx!=NO_DATA){
			dotsSelected.remove(sIdx);
			return true;
		}else{
			return false;
		}
	}
	private int checkSelected(int[] dot){
		for(int d=0;d<dotsSelected.size();d++){
			int[] dotS=dotsSelected.get(d);
			if(dotS[S_GROUP]==dot[S_GROUP] && dotS[S_NUMBER]==dot[S_NUMBER] && dotS[S_TYPE]==dot[S_TYPE]){
				return d;	//iz̔requalsł͂ȂjiArrays.equalsł悤j
			}
		}
		//
		return NO_DATA;
	}
	//
	public void exchangeSelectedDot(int[] oldDot,int[] newDot){
		//삵_Iς݂ł΁ȂI̓ê̂ɕύX˂΂ȂȂ
		int sIdx=checkSelected(oldDot);
		if(sIdx!=NO_DATA){
			//
			dotsSelected.remove(sIdx);
			//i폜łȂ΁j
			if(newDot!=null){
				dotsSelected.add(newDot);
			}
		}
		//ԍȂ_ύXꂽi폜ꂽĵł΁AIŁAȍ~̔ԍȂ_̗vfԍ-1˂΂ȂȂ
		if(oldDot[S_TYPE]==ST_FREE){
			for(int f=oldDot[S_NUMBER];f<groups[oldDot[S_GROUP]].dotFree.size();f++){
				int fIdx=checkSelected(new int[]{oldDot[S_GROUP],f+1,ST_FREE});	//O
				if(fIdx!=NO_DATA){
					dotsSelected.remove(fIdx);
					dotsSelected.add(new int[]{oldDot[S_GROUP],f,ST_FREE});		//
				}
			}
		}
	}
	//******************************************************************************************************
	// transferij
	//------------------------------------------------------------------------------------------------------
	public void transferSelectedDots(int targetGNI,DDControlDialog ctrl) {
		//
		for(int s=0;s<dotsSelected.size();s++) {
			int[] dot=dotsSelected.get(s);
			//֒ǉ
			switch(dot[S_TYPE]) {
			case ST_NUM:
				groups[targetGNI].addPointFree(groups[dot[S_GROUP]].dotNumber[dot[S_NUMBER]]);
				break;
			case ST_FREE:
				groups[targetGNI].addPointFree(groups[dot[S_GROUP]].dotFree.get(dot[S_NUMBER]));
				break;
			default:
			}
			//폜
			groups[dot[S_GROUP]].deletePoint(dot[S_TYPE], dot[S_NUMBER],ctrl);
		}
		//ił͕svj
		//dotsSelected.clear();
	}
	public void reselectTransferedDots(int gNI,int numS) {
		//
		for(int t=1;t<=numS;t++) {
			dotsSelected.add(new int[] {gNI,groups[gNI].dotFree.size()-t,ST_FREE});
		}
	}
	//******************************************************************************************************
	// ۑf[^ 
	//------------------------------------------------------------------------------------------------------
	public boolean setLoadString(String[] ld){
		//ꎞIɊi[imF̂߁j
		int tmpWidth,tmpHeight;
		DDGroup[] tmpGroups;
		//
		String[] sp;
		int dMx;
		//-----------------------------------------
		if(ld==null || ld.length<5 || ld.length%4!=1){
			return false;
		}
		tmpGroups=new DDGroup[ld.length/4];
		//-----------------------------------------
		sp=ld[0].split(",");
		if(sp.length!=3){
			return false;
		}
		try{
			tmpWidth=Integer.parseInt(sp[0]);
			tmpHeight=Integer.parseInt(sp[1]);
			dMx=Integer.parseInt(sp[2]);
		}catch(NumberFormatException nfe){
			return false;
		}
		//-----------------------------------------groups
		for(int g=0;g<tmpGroups.length;g++){
			int s=1+g*4;
			tmpGroups[g]=new DDGroup(dMx,this);
			boolean ret=tmpGroups[g].setLoadString(dMx, ld[s], ld[s+1], ld[s+2], ld[s+3]);
			if(!ret){
				return false;
			}
		}
		//-----------------------------------------
		//f[^Ă͂
		width=tmpWidth;
		height=tmpHeight;
		groups=tmpGroups;
		//
		return true;
	}
	//******************************************************************************************************
	// ۑf[^ o
	//------------------------------------------------------------------------------------------------------
	public String getSaveString(){
		final String BR=System.getProperty("line.separator");
		final String CM=",";
		//
		StringBuilder ret=new StringBuilder();
		//Z[uf[^쐬
		//
		ret.append(width).append(CM).append(height).append(CM).append(getNumberMax());
		ret.append(BR);
		//groups
		for(int g=0;g<groups.length;g++){
			ret.append(groups[g].getSaveString());
		}
		//
		return ret.toString();
	}
	//******************************************************************************************************
	// a擾
	//------------------------------------------------------------------------------------------------------
	public static int getRadius(int base){
		return (base>>1)+1;	//u+1vȂƗ̈̒[ł͂ݏoȂǂŃG[ɂȂ
	}
}
